Module javafx.base
Package javafx.beans.property

# Class MapPropertyBase<K,​V>

java.lang.Object
javafx.beans.binding.MapExpression<K,​V>
javafx.beans.property.ReadOnlyMapProperty<K,​V>
javafx.beans.property.MapProperty<K,​V>
javafx.beans.property.MapPropertyBase<K,​V>

Type Parameters:
  `K` - the type of the key elements of the `Map`
  `V` - the type of the value elements of the `Map`

All Implemented Interfaces:
  `Map<K,​V>`, `Observable`, `Property<ObservableMap<K,​V>>`, `ReadOnlyProperty<ObservableMap<K,​V>>`, `ObservableMapValue<K,​V>`, `ObservableObjectValue<ObservableMap<K,​V>>`, `ObservableValue<ObservableMap<K,​V>>`, `WritableMapValue<K,​V>`, `WritableObjectValue<ObservableMap<K,​V>>`, `WritableValue<ObservableMap<K,​V>>`, `ObservableMap<K,​V>`

Direct Known Subclasses:
  `SimpleMapProperty`

    public abstract class MapPropertyBase<K,​V>
    extends MapProperty<K,​V>

The class `MapPropertyBase` is the base class for a property wrapping an `ObservableMap`. It provides all the functionality required for a property except for the `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()` methods, which must be implemented by extending classes.

Since:
  JavaFX 2.1
See Also:
  `ObservableMap`, `MapProperty`

- ## Property Summary

  ### Properties declared in class javafx.beans.binding.MapExpression

  `empty, size`

- ## Nested Class Summary

  ## Nested classes/interfaces declared in interface java.util.Map

  `Map.Entry<K extends Object,​V extends Object>`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `MapPropertyBase()` | The Constructor of `MapPropertyBase`
  `MapPropertyBase​(ObservableMap<K,​V> initialValue)` | The constructor of the `MapPropertyBase`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `protected void` | `fireValueChangedEvent()` | Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `MapChangeListener`.
  `protected void` | `fireValueChangedEvent​(MapChangeListener.Change<? extends K,​? extends V> change)` | Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `MapChangeListener`.
  `protected void` | `invalidated()` | The method `invalidated()` can be overridden to receive invalidation notifications.
  `String` | `toString()` | Returns a string representation of this `MapPropertyBase` object.

  ### Methods declared in class javafx.beans.property.ReadOnlyMapProperty

  `bindContent, bindContentBidirectional, hashCode, unbindContent, unbindContentBidirectional`

  ### Methods declared in class javafx.beans.binding.MapExpression

  `asString, emptyProperty, getSize, isEqualTo, isNotEqualTo, isNotNull, isNull, mapExpression, sizeProperty, valueAt, valueAt`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface java.util.Map

  `clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, equals, forEach, get, getOrDefault, hashCode, isEmpty, keySet, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size, values`

  ### Methods declared in interface javafx.beans.Observable

  `addListener, removeListener`

  ### Methods declared in interface javafx.collections.ObservableMap

  `addListener, removeListener`

  ### Methods declared in interface javafx.beans.value.ObservableObjectValue

  `get`

  ### Methods declared in interface javafx.beans.value.ObservableValue

  `addListener, getValue, removeListener`

  ### Methods declared in interface javafx.beans.property.Property

  `bind, bindBidirectional, isBound, unbind, unbindBidirectional`

  ### Methods declared in interface javafx.beans.property.ReadOnlyProperty

  `getBean, getName`

  ### Methods declared in interface javafx.beans.value.WritableObjectValue

  `get, set`

  ### Methods declared in interface javafx.beans.value.WritableValue

  `getValue, setValue`

- ## Constructor Details

  - ### MapPropertyBase

    public MapPropertyBase()
    The Constructor of `MapPropertyBase`

  - ### MapPropertyBase

    public MapPropertyBase​(ObservableMap<K,​V> initialValue)
    The constructor of the `MapPropertyBase`.
    Parameters:
      `initialValue` - the initial value of the wrapped value

- ## Method Details

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent()
    Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `MapChangeListener`. This method is called when the value is changed, either manually by calling `WritableObjectValue.set(javafx.collections.ObservableMap)` or in case of a bound property, if the binding becomes invalid.

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent​(MapChangeListener.Change<? extends K,​? extends V> change)
    Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `MapChangeListener`. This method is called when the content of the list changes.
    Parameters:
      `change` - the change that needs to be propagated

  - ### invalidated

    protected void invalidated()
    The method `invalidated()` can be overridden to receive invalidation notifications. This is the preferred option in `Objects` defining the property, because it requires less memory. The default implementation is empty.

  - ### toString

    public String toString()
    Returns a string representation of this `MapPropertyBase` object.
    Overrides:
      `toString` in class `MapProperty<K,​V>`
    Returns:
      a string representation of this `MapPropertyBase` object.